'Program performs Hannan-Rinassen algorithm
'by Freddy Rojas 
'Universidad de Chile
'Rutgers University
'e-mail: frojasca@gmail.com
'last up date 09/25/2011

MODE VER4

'%%%%% PROCEDURES
include "C:\Users\Freddy\freddy_Backup\Freddy\Persona\Rutgers 2011\Semester III\Applied_macroeconometrics\eviews_codes\arma\arma_ols_reduction.prg"

include "C:\Users\Freddy\freddy_Backup\Freddy\Persona\Rutgers 2011\Semester III\Applied_macroeconometrics\eviews_codes\arma\arma.prg"
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cd "C:\Users\Freddy\freddy_Backup\Freddy\Persona\Rutgers 2011\Semester III\Applied_macroeconometrics\assignments\a1\data\xls\"
%fred="proj1data.xls"

wfopen(wf=pool, page=myproject) %fred

rename series01 serie1
rename series02 serie2

pagestruct(freq=u, start=1)


'SERIE's NAME
%y="serie2"
%const="c "                 ' with constant or not
%0=%y                        'depend variable
%date_i="1"                '1998:01" 'initial date
%date_f="500"             '2005:02" 'last date
!lagp=20                        'AR process 
!lagq=0                        'MA process

'Include estimation without or with backcast applied to MA terms
%bkcast="z,n" 'z means backcast OFF, n means HAC
'Information criteria schwarz, aic or hq
%icriterion="schwarz"


%lagp=@str(!lagp)

'CALLING ARMA
call  arma
smpl @all

freeze(Table_results) anex
Table_results(3,2)=%icriterion+" Criterion"

cd "C:\Users\Freddy\freddy_Backup\Freddy\Persona\Rutgers 2011\Semester III\Applied_macroeconometrics\assignments\a1\xls"
%i=%icriterion

Table_results.save(t=csv) Table_results_%y_%i_%lagp

'ls %y c AR(1) AR(2) AR(3) AR(4) AR(5) AR(6) AR(7) AR(8) AR(9)  AR(10) AR(11) AR(12) AR(13) AR(14) AR(15) AR(16) AR(17) AR(18) AR(19) AR(20)

genr resids_hat=resid

'Information required
%const="c "                 ' with constant or not
%0=%y                         'depend variable
%e_hat="resids_hat"   'resids hat
%date_i="1"                '1998:01" 'initial date
%date_f="500"             '2005:02" 'last date
!lagp=12                        'ARLags of dependent serie 
!lagq=10                        'MA process by using the resids hat
%icriterion="schwarz"
'-----------------------------------------------------------
%p=@str(!lagp)
%q=@str(!lagq)

call arma_ols_reduction
freeze(Table_results_ols) anex_ols

cd "C:\Users\Freddy\freddy_Backup\Freddy\Persona\Rutgers 2011\Semester III\Applied_macroeconometrics\assignments\a1\xls"
Table_results_ols.save(t=csv) Table_results_ols_%y_%i_%p_%q

cd "C:\Users\Freddy\freddy_Backup\Freddy\Persona\Rutgers 2011\Semester III\Applied_macroeconometrics\assignments\a1\wkfiles"

wfsave method_selecting_arma_%y

write(t=txt,na=.,d=c,dates) "C:\Users\Freddy\freddy_Backup\Freddy\Persona\Rutgers 2011\Semester III\Applied_macroeconometrics\assignments\a1\xls\data_{%y}.csv"  resids_hat %y

